commit 5782bacacada41c0240f5aceb42dcdf78e7042da
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Tue Oct 26 20:54:41 2021

    Fortran: do not restrict PDT KIND and LEN type parameters to default integer
    
    gcc/fortran/ChangeLog:
    
            PR fortran/102917
            * decl.c (match_attr_spec): Remove invalid integer kind checks on
            KIND and LEN attributes of PDTs.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/102917
            * gfortran.dg/pdt_4.f03: Adjust testcase.
    
    (cherry picked from commit cfcb27cfcb1d32b8cf7bc463cc1fc5cacae8d199)

diff --git a/gcc/fortran/decl.c b/gcc/fortran/decl.c
index 9b952b1bd75..4606155f699 100644
--- a/gcc/fortran/decl.c
+++ b/gcc/fortran/decl.c
@@ -5506,14 +5506,6 @@ match_attr_spec (void)
 		  m = MATCH_ERROR;
 		  goto cleanup;
 		}
-	      if (current_ts.kind != gfc_default_integer_kind)
-		{
-		  gfc_error ("Component with KIND attribute at %C must be "
-			     "default integer kind (%d)",
-			      gfc_default_integer_kind);
-		  m = MATCH_ERROR;
-		  goto cleanup;
-		}
 	    }
 	  else if (d == DECL_LEN)
 	    {
@@ -5533,14 +5525,6 @@ match_attr_spec (void)
 		  m = MATCH_ERROR;
 		  goto cleanup;
 		}
-	      if (current_ts.kind != gfc_default_integer_kind)
-		{
-		  gfc_error ("Component with LEN attribute at %C must be "
-			     "default integer kind (%d)",
-			      gfc_default_integer_kind);
-		  m = MATCH_ERROR;
-		  goto cleanup;
-		}
 	    }
 	  else
 	    {
diff --git a/gcc/testsuite/gfortran.dg/pdt_4.f03 b/gcc/testsuite/gfortran.dg/pdt_4.f03
index c1af65a5248..37412e4ca82 100644
--- a/gcc/testsuite/gfortran.dg/pdt_4.f03
+++ b/gcc/testsuite/gfortran.dg/pdt_4.f03
@@ -28,9 +28,9 @@ end module
 
   type :: bad_pdt (a,b, c, d)  ! { dg-error "does not have a component" }
     real, kind :: a            ! { dg-error "must be INTEGER" }
-    INTEGER(8), kind :: b      ! { dg-error "be default integer kind" }
+    INTEGER(8), kind :: b
     real, LEN :: c             ! { dg-error "must be INTEGER" }
-    INTEGER(8), LEN :: d       ! { dg-error "be default integer kind" }
+    INTEGER(8), LEN :: d
   end type
 
   type :: mytype (a,b)

